/*----------------------------------------------------
  xcryptor.c -- ஢ 䠩   28147-89 
		䨪  DOS/Win32.
  ࠡ⠫ ३ 쥢 ஢, .᪢
  (c) 1994-1998 FreeWare
   ᯮ짮  ஢.
  ----------------------------------------------------
   1.00      25.06.94,
   2.00      05.02.95.
   3.00      08.03.98.
   3.00      16.04.98.
   3.01      07.07.98.

  䨪      䨪  i8088-80286
  䨪-386 䨪  i386   /Win16
  䨪-W32 䨪  i386   Win32
  ----------------------------------------------------
   :
    訡  ᨨ 1.00,  㡫
   "" N 1/95  ⠪ ࠭塞  "-
  -᪮",  ணࠬ     ०
  ᮢ⨬  㪠 ᨥ   १⠬ -
  ஢.
  ----------------------------------------------------
    ᨨ 2.0   ( 1.0  㡫
    N1/95)
  -- inline help;
  --  ஢뢠 䠩 ,⭮ 8
       ⬠ ⮩ ;  
      㭪樨 ७   ExpKey33;
  -- ࠧࠡ⠭ ਠ  32-⮢ ஢
     ᥬ⢠ Intel 80x86;
  -- 祧   㦠 ७  
      128 ;    㦠  - 32
     ;
  --    ⥭ 䠩 뤥 ᪨ 
      ࠧ஬   ࠢ;
  --    ୠ ⨪ 訡 
     室 ;
  ----------------------------------------------------
    ᨨ 3.00
  -- ந ࠧ  ,    
     ஢  祭   箬 ᫮ 㭤
     ࠭祭 ⠭⮩ MaxKeyItems,   砫쭠
      ⠭ - 128,  ⠭ - 32;
  -- ந쭠 奬 ᯮ짮 ⮢ ,
         ப /m{0|1}...,
        ᮡ ᯮ짮   ணࠬ
     㭨ᠫ쭮 㭪樨 ७  ExpKey;
  -- ᨭய뫪   ந쭮,   ᨨ
     2.0    ᥣ ࠫ ࠢ 0;
  -- ᯮ 㣮 ᯮᮡ  ⮤ -
      -  ᨨ 2.0   ⤥ -
     箬   ப,   ⥯  ᨬ ⮤
     ᫥  ᨬ 樨 - ⠪ ;
  ----------------------------------------------------
    ᨨ 3.01
  -- ࠢ  訡,  ਢ  ୮ -
     ᫥ ⮢⠢;
  -- ᫨ ࠧ    㫥 (/Z0)
      ⠭ ࠢ ᨬ쭮 ⨬-
      ࠧ;
  --   ࠧ     /Z,  㪠-
      ࠧ୮ K ()  M (
     - ⮫쪮  Win32) - ਬ, /Z12K  /Z1M;
  -- ࠢ ⥪⮢ 뢮   ;
  ----------------------------------------------------
  ਠ ஢:
   VarKey:
  -- ᫨ ,   ணࠬ ॠ 
     ᯮ짮  ६ ࠧ  ந-
     쭮  ᪨  ࠢ  ᬮ ⮢
     ;
  -- ᫨  , ணࠬ  ண  
       ᯮ짮  䨪樨;
  ----------------------------------------------------
*/

#include <io.h> 	// open, filelength
#include <fcntl.h>	// O_xxxxx
#include <memory.h>     // memset,memcpy
#include <stdlib.h>	// strtoul,ultoa,toupper,
			// malloc,free
#include <ctype.h>      // toupper (BorlandC)
#include <stdio.h>      // printf
#include <string.h>     // strlen
#include <sys\stat.h>   // S_IREAD,S_IWRITE

#ifdef __BORLANDC__
#  include <alloc.h>      // farmalloc
#endif

#ifndef _WIN32
#  include <dos.h>      // farmalloc
#endif

#include "gost.h"       //   ⨯ 

#define DefaultBufferSize 512
#ifdef _WIN32
#  define far
#  define huge
#  define MaxBufferSize 1048576
#  define __memset memset
#  define __memcpy memcpy
#  define __malloc malloc
#  define __read(a,b,c)  _read(a,b,c)
#  define __write(a,b,c) _write(a,b,c)
#else
#  define MaxBufferSize 65528
#  define __memset _fmemset
#  define __memcpy _fmemcpy
#  define __malloc farmalloc
#  define __read(a,b,c)  (_dos_read(a,b,c,&bytesread),bytesread)
#  define __write(a,b,c) (_dos_write(a,b,c,&bytesread),bytesread)
#endif
enum { MaxKeyItems = 128 };

typedef enum
{
  O_K_=0,	    //  O.K.
  errDoNotMatch,    // ᮢ ⮢⠢
  errNoParam,       //   ࠬ஢
  errInvalidFlag,   //  䫠 맮 ணࠬ
  errBadMemorySize, // ୮  ࠧ 
  errMissingSynchro,//   /s  ᨭய뫪
  errBadSynchro,    // ୮  ᨭய뫪
  errBadImito,      // ୮  ⮢⠢
  errTooFiewParm,   //  ࠬ஢ 맮
  errTooManyParm,   //  ࠬ஢ 맮
  errMissingKey,    //   /k    䠩
  errBadKey,	    // 宩 䠩 
  errMissingXCHT,   //   /    䠩
  errBadXCHT,	    // 宩 䠩  ⠡楩 
  errInvalidOper,   // ୠ 
  errSourceFailure, // 訡  䠩-筨
  errNotDividedBy8, //  䠩  ⭠ 8
  errTargetFailure, // 訡  䠩-ਥ
  errRenameFailure, // 訡  २
  errDeleteFailure, // 訡  㤠 . 䠩
#ifdef VarKey
  errMissingScheme, //   /m  奬
  errBadScheme,     //   /m  ୠ 奬
  errKeyTooLong,    // 誮   ஢
#endif
  errInsufMemory,   //  墠⠥ ᪮ 
  dummy		    // 䨪⨢ 祭
} errList;

unsigned char chtab[1024];
void far* buffer=NULL;
unsigned long Memory=DefaultBufferSize;

Item	far *Key,       //   ஢
	far *KeyImito;	//   ࠡ⪨
			//   ⮢⠢
Item    Synchro[2]=	// ᨭய뫪
{
  0UL,0UL
};

Item	Imito[2]=
{
  0UL,0UL
};

Item    _Imito;

errList code=O_K_;	//  室

int	BackLink=  0;	// ஢  
int     ShowImito= 0;	//  ⮯⠢
int     CheckImito=0;	// ஢ ⮯⠢
int     Operation= 0;	// ஢
int	ParmCount= 0;   // 稪 ࠬ஢
int     Deletion=  0;	// 㤠 室
int     SimpleChange=0; //  
int     KeyRepeat= 4;   // ᫮ ७ 
int     KeyMask=   8;   // ⠭⭠ ᪠ 0001
int     KeySize=   32;  // ᫮ 㭤 ஢
int     iKeySize=  16;  // ᫮ 㭤 ⮢⠢

char	*KeyFile=  NULL;// 䠩 
char	*ChtFile=  NULL;// 䠩 ⠡ 
char	*InFile=   NULL;// 室 䠩
char	*OutFile=  NULL;// 䠩 १

#ifndef _WIN32
unsigned bytesread;     // ᯮ. ६
#endif

// ⨯ 㭪権

errList setParam        (int argc, char **argv);
errList	SignalError     (errList errType,
			 char *errPlace);
errList loadCht		(void);
errList loadKey		(void);
errList	execute         (void);

//  ணࠬ 

errList	main(int argc, char *argv[])
{
  unsigned short i;

#if defined(CPU386) && !defined(_WIN32)
  void ge386CPU(void);
  ge386CPU();
#endif

  printf(
#ifdef VarKey
	 "ணࠬ ஢   "
	 " ਠ⠬  28147-89\n"
#else
	 "ணࠬ ஢    2814"
	 "7-89\n"
#endif
         " 3.01"
#ifdef _WIN32
                    "-W32"
#else
#  ifdef CPU386
		    "-386"
#  endif
#endif
                        ",ࠧࠡ⠫ .஢, "
	 "᢮ ᯮ짮  ஢.\n"
);

//  横 ந ਢ ⠡ 
//  , ᫨ 㤥 樠஢  chtab
  for (i=0; i<1024; i++) chtab[i]=(unsigned char)i;

  return
    argc<=1 ? SignalError(errNoParam,NULL) :
      (code=setParam(argc,argv))!=O_K_ ? code :
	!InFile ? SignalError(errTooFiewParm,NULL) :
	  (ChtFile && loadCht() != O_K_) ?
		      SignalError(errBadXCHT,ChtFile) :
	    loadKey() != O_K_ ?
		      SignalError(errBadKey,KeyFile) :
	      execute();
}

// ⠭ ० ᮣ᭮ 䫠 맮

errList	setParam(int argc, char **argv)
{
  for ( ; ++argv,--argc; )	// ᬮ 㬥⮢
  {
    char *c,d;
    int length;

#ifdef VarKey
    int weight;
#endif


    if (**argv=='/')	//   ப
      switch (toupper(*(*argv+1)))  // 롮  㪢
      {
      case 'D': Deletion=1;			break;

      case 'K':
	if (!*(KeyFile=*argv+2))
	  return SignalError(errMissingKey,*argv);
	break;

      case 'C':
	if (!*(ChtFile=*argv+2))
	  return SignalError(errMissingKey,*argv);
	break;

      case 'Z':
	if (!*(*argv+2))
	  Memory=MaxBufferSize;
	else 
	{
	  Memory=strtoul(*argv+2,&c,10);
	  switch(*c)
	  {
            case 'K': case 'k': Memory *= 1024;    c++; break;
#ifdef _WIN32
            case 'M': case 'm': Memory *= 1048576; c++; break;
#endif
	  }
	}
	if (*c) return SignalError(errBadMemorySize,*argv+2);
	if (!Memory) Memory = MaxBufferSize;
	break;

      case 'S':
	if (!*(*argv+2))
	  return SignalError(errMissingSynchro,*argv+2);
	length=strlen(*argv);
	if (length<=10)
	  if (Synchro[0]=strtoul(*argv+2,&c,16),*c)
	    return SignalError(errBadSynchro,*argv+2);
	else
	{
	  if (Synchro[0]=strtoul(*argv+length-8,&c,16),*c)
	    return SignalError(errBadSynchro,*argv+2);
	  d=*(*argv+length-8);
	  *(*argv+length-8)=0;
	  if (Synchro[1]=strtoul(*argv+2,&c,16),*c)
	    return  *(*argv+length-8)=d,
		    SignalError(errBadSynchro,*argv+2);
	}
	break;

#ifdef VarKey
      case 'M':
	for (KeyRepeat=KeyMask=0, weight=1;
	     *(*argv+2+KeyRepeat);
	     KeyRepeat++,weight<<=1)
	{
	  switch(*(*argv+2+KeyRepeat))
	  {
	    default:
	      return SignalError(errBadScheme,*argv+2);
	    case '1':
	      KeyMask |= weight;
	    case '0':  ;
	  }
	}
	if (!KeyRepeat)
	  return SignalError(errMissingScheme,*argv+2);
	break;
#endif

      case 'I':
	if (*(*argv+2))
	  if (_Imito=strtoul(*argv+2,&c,16),*c)
	    return SignalError(errBadImito,*argv+2);
	  else CheckImito=ShowImito=1;
	else  ShowImito=1;
	break;
      default:
	return  SignalError(errInvalidFlag,*argv);
      }

    else switch(ParmCount++)    // 㣮 㬥
    {
      default:
	return  SignalError(errTooManyParm,*argv);
      case 0:			// 㥬 㭪
	if (*(*argv+1) && *(*argv+2)) // > 2 㪢
	  return SignalError(errInvalidOper,*argv);
	switch(toupper(**argv)) // ᨬ 樨 ?
	{
	  default:              // 訡
	    return SignalError(errInvalidOper,*argv);
	  case 'D': Operation=1;// ஢
	  case 'E':;            // ஢
	}
	switch(toupper(*(*argv+1))) // ᨬ ⮤ ?
	{
	  default:              // 訡
	    return SignalError(errInvalidOper,*argv);
	  case 'B':
	    SimpleChange=0; BackLink=1; break;
	  case 'G': case '\0':
	    SimpleChange=0; BackLink=0;	break;
	  case 'S':
	    SimpleChange=1; 		break;
	}
	break;
      case 1:			// ।塞 筨
	InFile=*argv;	break;
      case 2:			// ।塞 ਥ
	OutFile=*argv;
    }
  }
  return O_K_;
}

// 㧪 ⠡ 

errList loadCht(void)
{
  int	handle,FileSize;
  unsigned char  buffer[128];

  if ((handle=open(ChtFile,O_RDONLY|O_BINARY))==-1 ||
       ((FileSize=filelength(handle)) != 128 &&
			      FileSize != 1024) ||
    read(handle,
      FileSize==128 ? buffer : chtab,FileSize)==-1)
    return errBadKey;

  if (FileSize == 128)
    ExpCht((Item *)buffer,(Item *) chtab);
  close(handle);
  return O_K_;
}

// ஢ ᪨ 

  unsigned int inverse(unsigned int arg,
		       unsigned int size)
{
  unsigned int result = 0;
  for ( arg=~arg; size; size--)
  {
    result=(result<<1) + (arg & 1);
    arg >>= 1;
  }
  return result;
}

// 㧪 

errList loadKey(void)
{
  int		handle;
  unsigned long	FileSize;
  unsigned int  inverse(unsigned int arg, unsigned int size);

  if (KeyFile)
  {
    if ((handle=open(KeyFile,O_RDONLY|O_BINARY))==-1 ||
	((FileSize=filelength(handle))
#ifdef VarKey
	 % sizeof (Item)) || FileSize == 0)
#else
	 ) != 32)
#endif
      return errBadKey;
  }
  else
    FileSize = 32;

#ifdef VarKey
  if (FileSize / sizeof (Item) * KeyRepeat > MaxKeyItems)
    return errKeyTooLong;
  KeySize = FileSize / sizeof (Item) * KeyRepeat;
  iKeySize = 1 + (ShowImito && KeyRepeat > 2);
#else
  KeySize = 32;
  iKeySize = 1 + ShowImito;
#endif

  if (!(Key = __malloc((iKeySize+KeyRepeat)*FileSize)))
    return errInsufMemory;

  KeyImito = (Item far *)
    ((char huge *) Key + FileSize * KeyRepeat);

  if (KeyFile)
  {
    if (__read(handle, KeyImito, FileSize) <
		       (signed long) FileSize)
      return errBadKey;
  }
  else
    __memset(KeyImito, 0, FileSize);

  if (iKeySize == 2)
    __memcpy((char far *) KeyImito+FileSize,
			  KeyImito,FileSize);
  iKeySize*=FileSize/sizeof (Item);
  ExpandKey (KeyImito, Key, FileSize/sizeof (Item),
	     KeyRepeat,
	     SimpleChange && Operation ?
	       inverse(KeyMask,KeyRepeat) : KeyMask);
  close(handle);
  return O_K_;
}

//  ⢫ ஢

errList execute(void)
{
  int  inHandle,outHandle,same,lastloop;
  long FileSize;
  char number[11];
  unsigned long quant,blocks;

// ⮢ 䠩
  if (!BackLink && !SimpleChange)
    simple(Key,Synchro,chtab,1
#ifdef VarKey
    ,KeySize
#endif
    );
  if ((same=!OutFile)!=0)
    OutFile="$$$$$$$$.$$$";

  if((inHandle=open(InFile,O_RDONLY|O_BINARY))==-1 ||
     (FileSize=filelength(inHandle))== -1 ||
      FileSize == 0)
    return SignalError(errSourceFailure,InFile);
  if(SimpleChange && filelength(inHandle)%8)
    return SignalError(errNotDividedBy8,
      ultoa(filelength(inHandle),number,10));
  if((outHandle=open(OutFile,
		 O_WRONLY|O_CREAT|O_BINARY|O_TRUNC,
		 S_IREAD|S_IWRITE))==-1)
    return SignalError(errTargetFailure,OutFile);

// 뤥 
  if (Memory>(unsigned long)FileSize) Memory=FileSize;
  Memory=(Memory+7UL) & 0xFFFFFFF8UL;
  if (Memory>MaxBufferSize) Memory=MaxBufferSize;
  if(!(buffer=__malloc(Memory)))
    return SignalError(errInsufMemory,NULL);
    

// Notification
  printf("   - %lu ⮢\n",Memory);
  printf("%s஢ 䠩 %s"
#ifdef VarKey
         ", %s⠭ ०"
#endif
  "\n",
  Operation ? "" : "", InFile
#ifdef VarKey
  ,KeyMask==8 && KeyRepeat==4 && KeySize==32 ? "" : ""
#endif
  );

// 横 ஢
  for ( lastloop=0, blocks=(quant=Memory)/sizeof(CrBlock) ;
	    FileSize>0 ;
		FileSize-=Memory)
  {
    if ((unsigned long) FileSize < Memory)
	{
      quant = (unsigned long) FileSize;
      blocks= (quant+sizeof(CrBlock)-1)/sizeof(CrBlock);
	  lastloop = 1;
    }

    if ((unsigned long)__read(inHandle,buffer,quant) < quant)
      return SignalError(errSourceFailure,InFile);
    if (!Operation && ShowImito)
    {
      if (lastloop && FileSize % 8)
	__memset((char far *)buffer+FileSize, 0, 8-FileSize%8);
      imito (KeyImito,Imito,chtab,buffer,blocks
#ifdef VarKey
				       ,iKeySize
#endif
      );
    }
    if(SimpleChange)
      simple(Key,buffer,chtab,blocks
#ifdef VarKey
				    ,KeySize
#endif
      );
    else
      (BackLink ? Operation ? gammaLD : gammaLE : gamma)
	 (Key,Synchro,chtab,buffer,blocks
#ifdef VarKey
					 ,KeySize
#endif
	 );
    if (Operation && ShowImito)
    {
      if (lastloop && FileSize % 8)
	__memset((char far *)buffer+FileSize, 0, 8-FileSize%8);
      imito (KeyImito,Imito,chtab,buffer,blocks
#ifdef VarKey
					    ,iKeySize
#endif
	    );
    }
    if ((unsigned long)__write(outHandle,buffer,quant) < quant)
      return SignalError(errTargetFailure,OutFile);
  }

// 騥 ⢨
  close(inHandle);
  close(outHandle);
  if(ShowImito)
  {
    printf("⮢⠢");
    if(CheckImito)
      printf(" %s ᮢ !\n",
	 Imito[1]==_Imito ? "" : "  ");
    else
      printf("=%lx\n",Imito[1]);
  }
  if (Deletion || same)
  {
    if (unlink(InFile)==-1)
      return SignalError(errDeleteFailure,InFile);
    if (same && rename(OutFile,InFile)==-1)
      return SignalError(errRenameFailure,InFile);
  }
  return O_K_;
}

// 뤠 ᮮ饭  訡

errList	SignalError(errList errType, char *errPlace)
{
  char *errText[]=
  {
  " ᪠ ணࠬ : \" [/]... 㭪"
		 " 室 [१]\" , \n"
    "/ -   ᪮쪮 祩  ᫥饣 "
		 "᪠:\n"
    "  /d       - 㭨⮦ 室 䠩 ᫥ "
		 "譮 ஢;\n"
    "  /k<䠩>,/c<䠩> -  䠩  箬 (k) "
		 " ⠡楩   (c).   \n"
    "             <䠩> -  ⨬  MS-DOS "
		 " 䠩, 蠡 ⨬;\n"
    "              㬮砭   㫥   "
		 " ⮦⢥ ⠡ ;\n"
    "  /s<祭> -  ᨭய뫪, <祭>"
		 " -  1  16 16- ;\n"
#ifdef VarKey
    "  /m<奬> -  奬 ᯮ짮 "
		 " ,  <奬> - ᫥-\n"
    "             ⥫쭮 ⮢ 0  1, "
		 " אַ   冷;\n"
#endif
    "  /i[<祭>] -  ० ᫥ ⮢"
		 "⠢; ᫨ 祭 -  1\n"
    "              8 16-  - ,  "
		 " 뢮 १ \n"
    "             ࠢ  ᫥,  뢮"
		 " ᫥ 祭.\n"
#ifdef _WIN32
    "  /z[<ࠧ>[K|M]] । ࠧ  "
                 "  [K|M],  ᫨ ࠧ\n"
#else
    "  /z[<ࠧ>[K]]  । ࠧ   "
                 "   [K],  ᫨  ࠧ\n"
#endif
    "                , ࠢ 0   ॢ"
                 "蠥 ᨬ쭮 祭, \n"
    "              ᨬ쭮 祭, ᫨ "
                 "⥭ 8, 㣫 .\n"
    "㭪 - {e|d}[g|b|s] -1- ᨬ: e-஢"
		 ", d-஢; 2- ᨬ\n"
    "-⮤ ஢: g-஢ ( 㬮砭),"
		 "b-஢  ⭮ -\n"
    ", s- .  ᫥ 砥  "
		 "㥬 䠩 / ⭠ 8.\n"
    "室,१ -  㥬 䠩  䠩"
		 "   १.   ᫨\n"
    "䠩 १  ,   頥 㥬"
		 " 䠩.\n",
  " 䫠 맮 ணࠬ - \"%s\".  "
		 " ଠ樨  \n"
    "ப ணࠬ    ࠬ஢\n",
  "୮  ࠧ  - %s\n",
  "ய뫪    /s\n",
  "୮  ᨭய뫪 - %s\n",
  "୮  ⮯⠢ - %s\n",
  "室  㭪樨   㥬 䠩\n",
  "譨 ࠬ 맮 - %s\n",
  " 䠩  箬    /k\n",
  "୮  䠩  箬 - %s\n",
  " 䠩  ⠡楩     /c\n",
  "୮  䠩  ⠡楩  - %s\n",
  "୮  믮塞  - %s\n",
  "訡  室 䠩 - %s\n",
  " ⮩   䠩 - %s -  ⭠ 8\n",
  "訡  䠩 १ - %s\n",
  " २ 䠩 $$$$$$$$.$$$  %s\n",
  " 㤠 䠩 %s\n",
#ifdef VarKey
  "  /m  奬 ᯮ짮 \n",
  "  /m  ୠ 奬 - %s\n",
  "誮   ஢\n",
#endif
  " 墠⠥ ᪮ \n"
  };
  printf(errText[errType-2],errPlace);
  return errType;
}
